<template lang="html">
  <tr>
    <td>
      <item-details :details="details" :state="state" />
    </td>
    <td>
      <v-card>
        <v-card-text>
          <active
            :proposalId="details.proposalId"
            v-if="state === ProposalState.Active"
          />

          <succeeded
            :proposalId="details.proposalId"
            v-if="state === ProposalState.Succeeded"
          />

          <v-chip
            class="ma-2"
            filter
          >
            For {{ votes.forVotes }}
          </v-chip>

          <v-chip
            class="ma-2"
            filter
          >
            Against {{ votes.againstVotes }}
          </v-chip>

          <v-chip
            class="ma-2"
            filter
          >
            Abstain {{ votes.abstainVotes }}
          </v-chip>
        </v-card-text>
      </v-card>
    </td>
  </tr>
</template>

<script>
import { getGovernorSimpleCounting } from "@/helpers/contracts/governance";
import { ProposalState, ProposalStateIds } from "@/helpers/constants";
import Active from "./state/Active";
import Succeeded from "./state/Succeeded";
import ItemDetails from "./ItemDetails";
import { getTokenMetadata, decimalize } from "@/helpers/contracts/token.js";

export default {
  name: "Item",
  components: {
    Active,
    Succeeded,
    ItemDetails
  },
  data() {
    return {
      state: null,
      votes: {
        forVotes: 0,
        abstainVotes: 0,
        againstVotes: 0
      },
      ProposalState: ProposalState
    }
  },
  props: [
    "details"
  ],
  async created() {
    const governor = getGovernorSimpleCounting();
    const state = await governor.state(this.details.hash);
    this.state = ProposalStateIds[state];

    const votes = await governor.proposalVotes(this.details.hash);
    const token = await getTokenMetadata();

    this.votes.forVotes = decimalize(votes.forVotes.toString(), await token.decimals(), 4);
    this.votes.againstVotes = decimalize(votes.againstVotes.toString(), await token.decimals(), 4);
    this.votes.abstainVotes = decimalize(votes.abstainVotes.toString(), await token.decimals(), 4);
  }
}
</script>
